package cz.cr.sara.kytara.domain;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;

/**
 * Typ akordu.
 * @author lukas
 */
@Entity
@Table(name = "typAkordu")
@NamedQueries({ @NamedQuery(name = "TypAkordu.findById", query = "SELECT t FROM TypAkordu t WHERE t.id = :id"),
    @NamedQuery(name = "TypAkordu.allTypAkordu", query = "FROM TypAkordu"),
    @NamedQuery(name = "TypAkordu.allTriads",
        query = "FROM TypAkordu WHERE id IN (SELECT typAkordu FROM Interval GROUP BY typAkordu HAVING COUNT(*) = 2)"),
    @NamedQuery(name = "TypAkordu.typyByIntervaly",
        query = "FROM TypAkordu WHERE id IN (SELECT typAkordu FROM Interval WHERE interval IN (:intervaly) GROUP BY typAkordu HAVING COUNT(DISTINCT interval) = :pocetIntervalu)") })
public class TypAkordu
    implements Serializable {
  private static final long serialVersionUID = 1L;

  private String id; // ID typu akordu
  private String jmeno; // Jmeno akordu
  private String typ; // Typ akordu
  private String kategorie; // Kategorie akordu

  /**
   * @return Vrati ID typu akordu.
   */
  @Id
  @GeneratedValue(generator = "system-uuid")
  @GenericGenerator(name = "system-uuid", strategy = "uuid2")
  @Column(name = "id", nullable = false)
  public String getId() {
    return id;
  }

  /**
   * Ulozi ID typu akordu.
   * @param id - ID typu akordu.
   */
  public void setId(String id) {
    this.id = id;
  }

  /**
   * @return Vrati jmeno akordu.
   */
  @Column(name = "jmeno", nullable = false)
  public String getJmeno() {
    return jmeno;
  }

  /**
   * Ulozi jmeno akordu.
   * @param jmeno - jmeno akordu.
   */
  public void setJmeno(String jmeno) {
    this.jmeno = jmeno;
  }

  /**
   * @return Vrati typ akordu.
   */
  @Column(name = "typ", nullable = false)
  public String getTyp() {
    return typ;
  }

  /**
   * Ulozi typ akordu.
   * @param typ - typ akordu.
   */
  public void setTyp(String typ) {
    this.typ = typ;
  }

  /**
   * @return Vrati kategorii akordu.
   */
  @Column(name = "kategorie", nullable = false)
  public String getKategorie() {
    return kategorie;
  }

  /**
   * Ulozi kategorii akordu.
   * @param kategorie - kategorie akordu.
   */
  public void setKategorie(String kategorie) {
    this.kategorie = kategorie;
  }

  /**
   * Typ akordu.
   */
  @Override
  public String toString() {
    StringBuffer info = new StringBuffer(100);
    info.append("[ID='");
    info.append(id);
    info.append("',JMENO='");
    info.append(jmeno);
    info.append("',TYP='");
    info.append(typ);
    info.append("',KATEGORIE='");
    info.append(kategorie);
    info.append("']");
    return info.toString();
  }
}
