package cz.cr.sara.kytara.repository;

import java.util.List;

import cz.cr.sara.kytara.domain.TypAkordu;
import cz.cr.sara.kytara.service.pojos.Akord;

/**
 * Vyhledavani akordu v DBS.
 * @author lukas
 */
public interface AkordDAO {
  /**
   * Vyhleda a vrati pozadovany akord.
   * @param typAkordu - typ akordu.
   * @param nazev - nazev akordu.
   * @return Vrati pozadovany akord.
   */
  public Akord getAkordByTypAkorduAndNazev(String typAkordu,
      String nazev);

  /**
   * @return Vrati vsechny typy akordu.
   */
  public List<TypAkordu> getAllTypAkordu();

  /**
   * Vrati vsechny triady (akordy se tremi tony).
   * @return
   */
  public List<TypAkordu> getAllTriads();
  
  /**
   * Vyhleda a vrati pozadovanou triadu.
   * @param typAkordu - typ triady.
   * @param nazev - nazev triady.
   * @return Vrati pozadovanou triadu.
   */
  public Akord getTriadaByTypAkordu(String typTriady,
      String nazev);
  
  /**
   * Vyhleda a vrati typy akordu podle intervalu.
   * @param intervaly - seznam intervalu mezi tony akordu.
   * @return Vrati typy akordu podle intervalu.
   */
  public List<TypAkordu> getTypyAkorduByIntervaly(List<Integer> intervaly);
}
