package cz.cr.sara.kytara.repository;

import java.util.List;

import cz.cr.sara.kytara.domain.Ton;

/**
 * Vyhledavani tonu v DBS.
 * @author lukas
 */
public interface TonDAO {
  /**
   * Vrati ton pro pozadovane ID.
   */
  public Ton getTonById(final int id);

  /**
   * @return Vrati nazvy vsech tonu.
   */
  public List<String> getAllNazev();

  /**
   * @return Vrati ton se vsemi jeho polohami.
   */
  public Ton getAllPolohaByTonId(int tonId);

  /**
   * Vrati ton id podle jeho nazvu.
   * @param nazev
   * @return
   */
  public int getTonIdByTonNazev(String nazev);
  
  /**
   * Vrati vsechny tony.
   * @return
   */
  public List<Ton> getAllTony();
}
