package cz.cr.sara.kytara.repository.logic;

import java.util.List;

import cz.cr.sara.kytara.domain.Poloha;
import cz.cr.sara.kytara.domain.Ton;
import cz.cr.sara.kytara.service.pojos.PolohaAkordu;

/**
 * Vyhledani a sestaveni konkretni polohy / hmatu akordu.
 * @author lukas
 */
public interface PolohaAkorduIntelligence {
  /**
   * Vyhleda a sestavi konkretni polohu / hmat akordu.
   * @param zakladniTon - poloha akordu zakladniho tonu.
   * @param tony - seznam tonu.
   * @return Vrati polohu akordu.
   */
  public PolohaAkordu createPolohaAkordu(Poloha zakladniTon,
      List<Ton> tony);
  
  /**
   * Vyhleda a sestavi konkretni polohu / hmat triady.
   * @param zakladniTon - poloha triady zakladniho tonu.
   * @param tony - seznam tonu.
   * @return Vrati polohu triady.
   */
  public PolohaAkordu createPolohaTriady(Poloha zakladniTon,
      List<Ton> tony);
}
