package cz.cr.sara.kytara.repository.logic;

import java.util.List;

import cz.cr.sara.kytara.domain.Ton;
import cz.cr.sara.kytara.service.pojos.PolohaAkordu;

/**
 * Vyhledani poloh akordu.
 * @author lukas
 */
public interface RepositoryLogicPolohyAkordu {
  /**
   * Vyhledani poloh akordu.
   * @param tony - seznam tonu.
   * @param prvniTonNazev - nazev prvniho tonu.
   * @return Vrati polohy akordu.
   */
  public List<PolohaAkordu> getPolohyAkorduByTony(List<Ton> tony,
      String prvniTonNazev);
  
  /**
   * Vyhledani poloh triady.
   * @param tony - seznam tonu.
   * @param prvniTonNazev - nazev prvniho tonu.
   * @return Vrati polohy triady.
   */
  public List<PolohaAkordu> getPolohyTriadyByTony(List<Ton> tony,
      String prvniTonNazev);
}
