package cz.cr.sara.kytara.service;

import java.util.List;
import java.util.Set;

import cz.cr.sara.kytara.domain.Pisen;

/**
 * Manager pro vyhledavani pisni.
 * @author lukas
 */
public interface PisenManager {

  /**
   * Vyhleda a vrati vsechny pisne.
   * @return Vrati vsechny pisne.
   */
  public List<Pisen> getAllPisen();

  /**
   * Vyhleda a vrati pisen podle id.
   * @param id - id pisne.
   * @return Vrati pisen podle id.
   */
  public Pisen getPisenById(String id);

  /**
   * Vyhleda a vrati jmena akordu v pisni.
   * @param pisen - pisen.
   * @return Vrati jmena akordu v pisni.
   */
  public Set<String> getJmenaAkorduVPisni(Pisen pisen);
}
