package cz.cr.sara.kytara.service.impl;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cz.cr.sara.kytara.domain.Pisen;
import cz.cr.sara.kytara.repository.PisenDAO;
import cz.cr.sara.kytara.service.PisenManager;

@Service("pisenManager")
public class PisenManagerImpl
    implements PisenManager {
  private final String ODDELOVAC_AKORDU_ZACATEK = "|";
  private final String ODDELOVAC_AKORDU_KONEC = "\\";
  private final String ODDELOVAC_AKORDU_SPECIALNI_POSUN = "$";

  @Autowired
  PisenDAO pisenDao;

  @Override
  public List<Pisen> getAllPisen() {
    return pisenDao.getAllPisen();
  }

  @Override
  public Pisen getPisenById(String id) {
    return pisenDao.getPisenById(id);
  }

  @Override
  public Set<String> getJmenaAkorduVPisni(Pisen pisen) {
    Set<String> akordy = new HashSet<String>();
    String text_ = pisen.getObsah();
    int pos = text_.indexOf(ODDELOVAC_AKORDU_ZACATEK);
    while (pos >= 0) {
      text_ = text_.substring(pos + 1);
      pos = text_.indexOf(ODDELOVAC_AKORDU_ZACATEK);
      if (pos > 0) {
        String text__ = text_.substring(0,
            pos);
        int pos1 = text__.indexOf(ODDELOVAC_AKORDU_KONEC);
        int pos2 = text__.indexOf(ODDELOVAC_AKORDU_SPECIALNI_POSUN);
        pos1 = (pos1 <= pos2)
            ? pos2
            : pos1;
        if (pos1 > 0) {
          akordy.add(text__.substring(0,
              pos1));
          text_ = text_.substring(pos);
          pos = 0;
        }
        else {
          akordy.add(text__);
          text_ = text_.substring(pos + 1);
          pos = text_.indexOf(ODDELOVAC_AKORDU_ZACATEK);
        }
      }
      else {
        int pos1 = text_.indexOf(ODDELOVAC_AKORDU_KONEC);
        akordy.add(text_.substring(0,
            pos1));
        pos = -1;
      }
    }
    return akordy;
  }
}
