package cz.cr.sara.kytara.service.logic.impl;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import cz.cr.sara.kytara.ciselniky.AkordVyber;
import cz.cr.sara.kytara.domain.Ton;
import cz.cr.sara.kytara.service.AkordManager;
import cz.cr.sara.kytara.service.logic.BuildAkordInfo;
import cz.cr.sara.kytara.service.pojos.BuildAkordu;

@Component("buildAkordInfo")
public class BuildAkordInfoImpl
    implements BuildAkordInfo {

  @Autowired
  private AkordManager akordManager;

  private static final int pocetTonu = 12;

  @Override
  public List<BuildAkordu> getIntervalyByTonyId(List<Integer> tonyId) {
    List<BuildAkordu> buildAkordy = new ArrayList<BuildAkordu>(tonyId.size());
    //nastavi zakladni ton id
    for (Integer zakladniTonId : tonyId) {
      BuildAkordu build = new BuildAkordu();
      List<Integer> intervaly = new ArrayList<Integer>(tonyId.size() - 1);
      build.setZakladniTonId(zakladniTonId);
      //nastavi intervaly od jinych tonu nez zakladniho
      for (Integer tonId : tonyId) {
        if (build.getZakladniTonId() != tonId) {
          int interval = getIntervalByTonId(zakladniTonId,
              tonId);
          intervaly.add(interval);
        }
      }
      build.setIntervaly(intervaly);
      buildAkordy.add(build);
    }
    return buildAkordy;
  }

  /**
   * Vraci interval mezi zakladnim tonem a aktualnim tonem.
   * @param zakladniTonId - id zakladniho tonu.
   * @param tonId - id aktualniho tonu.
   * @return Vraci interval mezi zakladnim tonem a aktualnim tonem.
   */
  private int getIntervalByTonId(int zakladniTonId,
      int tonId) {
    if (tonId > zakladniTonId) {
      return tonId - zakladniTonId;
    }
    else {
      return pocetTonu - (zakladniTonId - tonId);
    }
  }

  @Override
  public String getTonNazevByTonId(int id) {
    List<Ton> tony = AkordVyber.getInstance(this.akordManager).getVyberAkordu().getTony();
    String nazev = "";
    for (Ton ton : tony) {
      if (ton.getId() == id) {
        nazev = ton.getNazev();
      }
    }
    return nazev;
  }
}
