package cz.cr.sara.kytara.service.pojos;

import java.util.List;

import cz.cr.sara.kytara.domain.Ton;
import cz.cr.sara.kytara.service.logic.impl.AkordPisenMapperImpl;

/**
 * Informace o akordu.
 * @author lukas
 */
public class Akord {
  private String nazev; // Nazev akordu
  private List<Ton> tony; // Seznam tonu
  private List<PolohaAkordu> polohyAkordu; // Seznam poloh akordu

  /**
   * Informace o akordu.
   */
  public Akord() {
  }

  /**
   * Informace o akordu.
   * @param zakladniTon - zakladni ton akordu.
   * @param typAkordu - typ akordu.
   * @param tony - seznam tonu.
   * @param polohyAkordu - seznam poloh akordu.
   */
  public Akord(String zakladniTon,
      String typAkordu,
      List<Ton> tony,
      List<PolohaAkordu> polohyAkordu) {
    this.nazev = zakladniTon + AkordPisenMapperImpl.NAZEV_AKORDU_ODDELENI + typAkordu;
    this.tony = tony;
    this.polohyAkordu = polohyAkordu;
  }

  public String getNazev() {
    return nazev;
  }

  public void setNazev(String nazev) {
    this.nazev = nazev;
  }

  public List<Ton> getTony() {
    return tony;
  }

  public void setTony(List<Ton> tony) {
    this.tony = tony;
  }

  public List<PolohaAkordu> getPolohyAkordu() {
    return polohyAkordu;
  }

  public void setPolohyAkordu(List<PolohaAkordu> polohyAkordu) {
    this.polohyAkordu = polohyAkordu;
  }

  /**
   * Informace o akordu.
   */
  @Override
  public String toString() {
    StringBuffer info = new StringBuffer(100);
    info.append("[NAZEV-AKORDU='");
    info.append(nazev);
    info.append("',SEZNAM-TONU=");
    info.append(tony);
    info.append(",SEZNAM-POLOH-AKORDU=");
    info.append(polohyAkordu);
    info.append("]");
    return info.toString();
  }
}
