package cz.cr.sara.kytara.service.pojos;

/**
 * Informace o zvolenem akordu.
 * @author lukas
 */
public class AkordInfo
    implements Comparable<AkordInfo> {
  private String ton; // Ton
  private String typAkordu; // Typ akordu

  public String getTon() {
    return ton;
  }

  public void setTon(String ton) {
    this.ton = ton;
  }

  public String getTypAkordu() {
    return typAkordu;
  }

  public void setTypAkordu(String typAkordu) {
    this.typAkordu = typAkordu;
  }

  /**
   * Porovnani podle tonu a typu akordu.
   */
  @Override
  public int compareTo(AkordInfo akordInfo) {
    if (this.ton != null && akordInfo.ton == null)
      return 1;
    if (this.ton == null && akordInfo.ton != null)
      return -1;
    int diff = this.ton.compareTo(akordInfo.ton);
    if (diff != 0) {
      return diff;
    }

    if (this.typAkordu != null && akordInfo.typAkordu == null)
      return 1;
    if (this.typAkordu == null && akordInfo.typAkordu != null)
      return -1;
    return this.typAkordu.compareTo(akordInfo.typAkordu);
  }

  /**
   * Informace o zvolenem akordu.
   */
  @Override
  public String toString() {
    StringBuffer info = new StringBuffer(50);
    info.append("[TON='");
    info.append(ton);
    info.append("',TYP-AKORDU='");
    info.append(typAkordu);
    info.append("']");
    return info.toString();
  }
}
