package cz.cr.sara.kytara.web;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import cz.cr.sara.kytara.ciselniky.PisenVyber;
import cz.cr.sara.kytara.domain.Pisen;
import cz.cr.sara.kytara.service.AkordManager;
import cz.cr.sara.kytara.service.PisenManager;

/**
 * Kontroler pro pisne.
 * @author lukas
 */
@Controller
@RequestMapping("/pisne")
public class PisenController {

  @Autowired
  private PisenManager pisenManager;

  @Autowired
  private AkordManager akordManager;

  /**
   * Vyhledavani a zobrazovani vsech pisni.
   */
  @RequestMapping(value = { "/pisne" }, method = { RequestMethod.GET,
      RequestMethod.POST })
  protected String allPisne(@ModelAttribute("pisen") Pisen pisen,
      Model model) {
    // Vyber pisni
    PisenVyber pisenVyber = PisenVyber.getInstance(pisenManager, akordManager);

    if (pisen.getId() != null) {
      Pisen vybranaPisen = pisenVyber.getPisenById(pisen.getId());
      model.addAttribute("pisen",
          vybranaPisen);
    }
    else {
      model.addAttribute("pisen",
          pisen);
    }

    // Seznam pisni
    List<Pisen> pisne = pisenVyber.getPisne();
    model.addAttribute("pisne",
        pisne);

    return "/pisne/pisne";
  }
}
