package cz.cr.sara.kytara.web;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import cz.cr.sara.kytara.ciselniky.TonVyber;
import cz.cr.sara.kytara.domain.Ton;
import cz.cr.sara.kytara.service.TonManager;
import cz.cr.sara.kytara.view.TonView;

/**
 * Kontroler pro triady.
 * @author lukas
 */
@Controller
@RequestMapping("/tony")
public class TonyFormController {
  /** Implicitne vyhledavany ton */
  private static final String TON = "C";

  @Autowired
  private TonManager tonManager;

  private static final Logger log = LoggerFactory.getLogger(TonyFormController.class);

  /**
   * Vyhledavani a zobrazovani kytarovych triad.
   */
  @RequestMapping(value = { "/tony" }, method = { RequestMethod.POST,
      RequestMethod.GET })
  protected ModelAndView tonyFind(@ModelAttribute("tonInfo") Ton tonInfo) {
    if (tonInfo.getNazev() == null) {
      tonInfo.setNazev(TonyFormController.TON);
    }
    // Vyber tonu
    TonVyber tonVyber = TonVyber.getInstance(tonManager);

    // Vyhledani tonu
    Ton vybranyTon = tonManager.getTonByTonNazev(tonInfo.getNazev());

    // Informace o vyhledanem tonu
    TonView tonView = new TonView(vybranyTon,
        tonVyber.getAllTony().getNazvyTonu());

    if (log.isInfoEnabled()) {
      log.info("Nazev tonu: {}.",
          tonView.getTon());
      log.info("Seznam nazvu tonu: {}.",
          tonView.getNazvyTonu());
      log.info("Hmat tonu: {}.",
          tonView.getHmat());
    }
    log.info("projde dvakrat konec {}.", tonInfo);
    return new ModelAndView("/tony/tony",
        "tonView",
        tonView);
  }
}