<%-- Vyhledavani a zobrazovani kytarovych akordu --%>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>

<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="description" content="Kytarove akordy" />
<meta name="keywords" content="Kytarove akordy, Kytara, Luky" />
<meta name="author" content="Luky" />
<link rel="shortcut icon"
	href="${pageContext.request.contextPath}/resources/img/logo.png" />
<title>Kytara - Kytarové akordy</title>
<%@ include file="/WEB-INF/include/taglib.inc"%>
<%@include file="/WEB-INF/include/bootstrap.inc"%>
<%@include file="/WEB-INF/include/kytara.inc"%>
<script src="<c:url value="/resources/js/akordy.js" />"></script>
<!-- HTML5 Shim and Respond.js IE8 support of HTML5 elements and media queries -->
<!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
<!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
</head>
<body>
	<%-- Hlavni menu --%>
	<%@include file="/WEB-INF/jsp/shared/menu.jsp"%>

	<%-- Obsah --%>
	<div class="container-fluid">
		<main> <%-- Prvni sloupec --%>
		<div class="col-sm-3">
			<%@include file="../shared/canvas.jsp"%>
		</div>
		<%-- Druhy sloupec --%>
		<div class="col-sm-9">
			<article>
				<header>
					<div class="well row">
						<h1>
							<small>Akord</small>&nbsp;&nbsp;
							<c:out value="${akord.nazev}" />
						</h1>
						<div class="row text-primary col-sm-12">
							Tóny
							<c:forEach items="${akord.tony}" var="ton">
					&nbsp;&nbsp;<span class="glyphicon glyphicon-forward"></span>&nbsp;&nbsp;
					<button type="button" class="btn btn-default" disabled="disabled">
									<c:out value="${ton}" />
								</button>
							</c:forEach>
						</div>
					</div>
				</header>

				<section>
					<div class="table-responsive">
						<table class="table table-striped" id="tabAkordy">
							<%-- Polohy akordu --%>
							<tr class="info">
								<th>Polohy akordu</th>
							</tr>
							<tr>
								<td>
									<div class="alert alert-warning" id="polohy">
										<c:forEach items="${akord.hmaty}" var="hmat">
											<c:if test="${hmat.poradi > 1}">
												&nbsp;&nbsp;<span class="glyphicon glyphicon-forward"></span>&nbsp;&nbsp;
											</c:if>
											<button type="button" class="btn btn-success"
												<c:if test="${hmat.poradi == 1}"> id="prvniPoloha"</c:if>
												value="<c:out value="${hmat.prazce}" />"
												title="<c:out value="${hmat.poradi}" />.&nbsp;poloha akordu">
												&nbsp;<span class="badge"><c:out
														value="${hmat.poradi}" /></span>&nbsp;
											</button>
										</c:forEach>
									</div>
								</td>
							</tr>

							<%-- Volba noveho akordu --%>
							<tr class="info">
								<th>Vyhledání akordu</th>
							<tr>
								<td><form:form method="post" commandName="akordInfo"
										action="/kytara/akordy/akordy" class="form form-horizontal"
										role="form">
										<form:input type="hidden" path="ton" id="ton"
											value="${akord.ton}" />
										<div class="form-group">
											<%-- Volba tonu --%>
											<div class="col-sm-7">
												<%@include file="../shared/volbaTonu.jsp"%>
											</div>
											<div class="col-sm-5">
												<%@include file="../shared/volbaTypAkordu.jsp"%>
												<div class="form-group">
													<div class="col-sm-8 col-sm-offset-2">
														<button type="submit" class="btn btn-primary pull-right">
															<span class="glyphicon glyphicon-ok "></span>&nbsp;&nbsp;
															Vyhledat akord
														</button>
													</div>
												</div>
											</div>
										</div>
									</form:form></td>
							</tr>
						</table>
					</div>
				</section>
			</article>
		</div>
		</main>
		<%-- Paticka --%>
		<%@include file="/WEB-INF/jsp/shared/footer.jsp"%>
	</div>
</body>
</html>