<%-- Vyhledavani a zobrazovani kytarovych akordu --%>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>

<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="description" content="Kytarove akordy" />
<meta name="keywords" content="Kytarove akordy, Kytara, Luky" />
<meta name="author" content="Luky" />
<link rel="shortcut icon"
	href="${pageContext.request.contextPath}/resources/img/logo.png" />
<title>Kytara - Výběr akordu</title>
<%@ include file="/WEB-INF/include/taglib.inc"%>
<%@include file="/WEB-INF/include/bootstrap.inc"%>
<%@include file="/WEB-INF/include/kytara.inc"%>
<script src="<c:url value="/resources/js/findAkord.js" />"></script>
<!-- HTML5 Shim and Respond.js IE8 support of HTML5 elements and media queries -->
<!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
<!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
</head>
<body>
	<%-- Hlavni menu --%>
	<%@include file="/WEB-INF/jsp/shared/menu.jsp"%>

	<%-- Obsah --%>
	<div class="container-fluid">
		<main> <%-- Prvni sloupec --%>
		<div class="col-sm-4">
			<%@include file="../shared/canvas.jsp"%>
			<div id='panel'>
				<script src="<c:url value="/resources/js/generujTony.js" />"></script>
			</div>
		</div>
		<%-- Druhy sloupec --%>
		<div class="col-sm-8">
			<article>
				<header>
					<div class="well row">
						<h3>Tóny pro výběr akordu</h3>
						<br>
						<div id="seznamTonu" class="row text-primary col-sm-12">
							Vybrané tóny
							<c:forEach items="${tony}" var="ton">
					&nbsp;&nbsp;<span class="glyphicon glyphicon-forward"></span>&nbsp;&nbsp;
							<button type="button" class="btn btn-default" disabled="disabled"
									value="${ton.id}">
									<c:out value="${ton.nazev}" />
								</button>
							</c:forEach>
						</div>
					</div>
				</header>

				<%-- Seznam moznych akordu --%>
				<section>
					<div class="alert alert-warning">
						<h3>Možné akordy</h3>
						<nav>
							<ul class="pager" id="mozneAkordy"></ul>
						</nav>
					</div>
				</section>
			</article>
		</div>
		</main>
		<%-- Paticka --%>
		<%@include file="/WEB-INF/jsp/shared/footer.jsp"%>
	</div>
</body>
</html>