<%-- Vyhledavani a zobrazovani tonu --%>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>

<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="description" content="Kytarove akordy" />
<meta name="keywords" content="Kytarove akordy, Kytara, Luky" />
<meta name="author" content="Luky" />
<link rel="shortcut icon"
	href="${pageContext.request.contextPath}/resources/img/logo.png" />
<title>Kytara - Tóny na pražci</title>
<%@ include file="/WEB-INF/include/taglib.inc"%>
<%@include file="/WEB-INF/include/bootstrap.inc"%>
<%@include file="/WEB-INF/include/kytara.inc"%>
<script src="<c:url value="/resources/js/tony.js" />"></script>
<!-- HTML5 Shim and Respond.js IE8 support of HTML5 elements and media queries -->
<!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
<!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
</head>
<body>
	<%-- Hlavni menu --%>
	<%@include file="/WEB-INF/jsp/shared/menu.jsp"%>

	<%-- Obsah --%>
	<div class="container-fluid">
		<main> <%-- Prvni sloupec --%>
		<div class="col-sm-3">
			<jsp:include page="../shared/canvas.jsp" />
		</div>
		<%-- Druhy sloupec --%>
		<div class="col-sm-9">
			<article>
				<header>
					<div class="well row">
						<h1>
							<small>Tón</small>&nbsp;&nbsp;
							<c:out value="${tonView.ton}" />
						</h1>
					</div>
				</header>

				<section>
					<div class="table-responsive" id="polohy">
						<input type="hidden" class="inp" id="jedinaPoloha"
							value="<c:out value="${tonView.hmat.prazce}" />">
						<table class="table table-striped" id="tabAkordy">
							<%-- Volba noveho tonu --%>
							<tr class="info">
								<th>Vyhledání tónu</th>
							</tr>
							<tr>
								<td><form:form method="post" commandName="tonInfo"
										id="myForm" action="/kytara/tony/tony"
										class="form form-horizontal" role="form">
										<form:input type="hidden" path="nazev" id="ton"
											value="${tonView.ton}" />
										<div class="form-group">
											<%-- Volba tonu --%>
											<div class="col-sm-7">
												<div class="alert alert-warning">
													<div>
														<label>Tóny</label>
													</div>
													<div class="table-responsive" id="tony">
														<table class="table table-striped">
															<c:forEach items="${tonView.nazvyTonu}" var="lineTony">
																<tr>
																	<c:forEach items="${lineTony}" var="ton">
																		<td align="center">&nbsp;
																			<button type="button" class="buttons"
																				<c:if test="${ton eq tonView.ton}"> id="prvniTon"</c:if>
																				value="<c:out value="${ton}" />">
																				&nbsp;
																				<span class="tonNazev"><c:out value="${ton}" /></span>
																				&nbsp;
																			</button> &nbsp;
																		</td>
																	</c:forEach>
															</c:forEach>
														</table>
													</div>
												</div>
											</div>
										</div>
										<div class="form-group">
											<div class="col-sm-3 col-sm-offset-2">
												<button type="submit" class="btn btn-primary pull-right">
													<span class="glyphicon glyphicon-ok "></span>&nbsp;&nbsp;
													Vyhledat ton
												</button>
											</div>
										</div>
									</form:form></td>
							</tr>
						</table>
					</div>
				</section>
			</article>
		</div>
		</main>
		<%-- Paticka --%>
		<%@include file="/WEB-INF/jsp/shared/footer.jsp"%>
	</div>
</body>
</html>