var menuItems = new Array();

window.onload = load();
window.onresize = function() {
  resize();
};

function load() {
  return function() {
    resize();
  };
}

// Prekresleni menu
function resize() {
  var navs = document.querySelectorAll("nav[data-radial-menu] > ul > li");
  for ( var i = 0; i < navs.length; i++) {
    var radialMenu = new RadialMenu(navs[i]);
    radialMenu.fill();
    menuItems.push(radialMenu);
  }
};

// Maximalni sirka a vyska hlavniho elemenu 'li'
function maxSize(datasize) {
  getViewportSize = function() {
    return {
      height : window.innerHeight,
      width : window.innerWidth
    };
  };

  var viewportSize = getViewportSize();
  var maxSize = viewportSize.width;
  if (viewportSize.height < maxSize) {
    maxSize = viewportSize.height;
  }
  maxSize = parseInt(maxSize * datasize);
  return maxSize;
};

// Objekt jedne polozky menu
var RadialMenu = (function() {
  var PIOVER180 = Math.PI / 180;

  function _constructor(element) {
    this.element = element;
    this.size;
    this.name = "";
    this.children = new Array();
  }

  var _proto = {};
  // Nastaveni sirky a vysky hlavniho elemenu 'li' - podle zadaneho atributu
  // 'data-size'
  _proto.setSize = function() {
    var datasize = this.element.getAttribute("data-size");
    if (datasize == null) {
      datasize = 0.35;
    }
    this.size = maxSize(datasize);
    this.element.style.width = this.size + "px";
    this.element.style.height = this.size + "px";
  };

  // Naplneni potomku daneho elementu
  _proto.fillChildren = function() {
    for ( var i = 0; i < this.element.childNodes.length; i++) {
      // Nazev potomka
      switch (this.element.childNodes[i].nodeName) {
      case "SPAN": // Nazev menu
        this.name = this.element.childNodes[i].textContent;
        break;
      case "UL": // Submenu
        // Ulozeni polozek submenu
        for ( var u = 0; u < this.element.childNodes[i].childNodes.length; u++) {
          if (this.element.childNodes[i].childNodes[u].nodeName == "LI") {
            var menu = new RadialMenu(this.element.childNodes[i].childNodes[u]);
            this.children.push(menu);
          }
        }

        // Nastaveni velikosti podpolozek
        this.setSizes();
        // Nastaveni pozic podpolozek
        this.setPositions();

        break;
      }
    }
  };

  // Nastaveni velikosti podpolozek
  // Projdeme všechny submenu a pokud nemají definovaný attribut data-size,
  // nastavíme 25% velikosti z předka
  _proto.setSizes = function() {
    for ( var i = 0; i < this.children.length; i++) {
      var menu = this.children[i];
      var datasize = menu.element.getAttribute("data-size");
      if (datasize != null) {
        menu.size = datasize;
      } else {
        menu.size = this.size * 0.25;
      }
      menu.element.style.width = menu.size + "px";
      menu.element.style.height = menu.size + "px";
    }
  };

  // Nastaveni pozic podpolozek
  _proto.setPositions = function() {
    if (this.children.length > 0) { // Existuje podmenu
      // Pocet stupnu mezi jednotlivymi polozkami menu
      var degressBetweenSubItems = 360 / this.children.length;

      for ( var i = 0; i < this.children.length; i++) {
        // Na jakych stupnich bude polozka menu otocena
        var degress = (degressBetweenSubItems * i);

        var menu = this.children[i];

        // Pozice 'x' dane polozky menu
        var cos = Math.cos(PIOVER180 * degress);
        var x = this.size / 2 + (cos * this.size / 2) - menu.size / 2;

        // Pozice 'y' dane polozky menu
        var sin = Math.sin(PIOVER180 * degress);
        var y = this.size / 2 + (sin * this.size / 2) - menu.size / 2;

        menu.element.style.top = y + "px";
        menu.element.style.left = x + "px";
      }
    }
  };

  // Naplneni jedne polozky menu
  _proto.fill = function() {
    this.setSize();
    this.fillChildren();
  };

  _constructor.prototype = _proto;

  return _constructor;
})();