// Zobrazovani kytarovych akordu
var pocetVlakenScroll = 0;
$(document).ready(function() {

	$(document).on('click', '#polohy .btn', function() {
		enablePoloha();
		disableElement(this);

		vykresliPolohu($(this).val().split('|'));
	});
	function enablePoloha() {
		$("#polohy .btn").each(function() {
			$(this).removeAttr("disabled");
			$(this).attr("class", "btn btn-success");
		});
	}

	// Event delegation
	$(document).on('click', '.akord', function() {
		var akord = $(this).text().replace(/\s/g, '');
		var text = $('#akordData').data("akordy-info");
		var akordNazevPolohy = getNazevAPolohy(text);
		$.each(akordNazevPolohy, function(i) {
			if (akord == akordNazevPolohy[i][0]) {
				var polohyAPoradi = getPolohyAPoradi(akordNazevPolohy[i][1]);
				pridejInfoDoJSP(akordNazevPolohy[i][0], polohyAPoradi);
				vykresliPolohu(polohyAPoradi[0][0].split('|'));
			}
		});
	});

	// Vrati 2-rozmerne pole s nazvy akordu a jejich polohami
	function getNazevAPolohy(text) {
		var akordInfo = text.split('&');
		var akordNazevPolohy = new Array();
		$.each(akordInfo, function(i) {
			var nazvy = akordInfo[i].split('#');
			akordNazevPolohy.push(nazvy);
		});
		return akordNazevPolohy;
	}

	// Prida info o vybranem akordu a jeho polohach
	function pridejInfoDoJSP(akordNazev, polohyAPoradi) {
		$('#canvasAkordNazev').text(akordNazev);
		$('#polohy').empty();
		$.each(polohyAPoradi, function(i) {
			jQuery('<button/>', {
				id : polohyAPoradi[i][1],
				type : 'button',
				class : 'btn btn-success',
				value : polohyAPoradi[i][0],
				title : polohyAPoradi[i][1] + '. poloha akordu',
			}).appendTo('#polohy');

			jQuery('<span/>', {
				class : 'badge',
				text : polohyAPoradi[i][1]
			}).appendTo('#' + polohyAPoradi[i][1]);
		});
		disableElement('#polohy #1');
	}

	// Vrati 2-rozmerne pole s polohou a poradim polohy od
	// vybraneho akordu
	function getPolohyAPoradi(akordPolohy) {
		var polohyInfo = akordPolohy.split('*');
		var polohyAPoradi = new Array();
		$.each(polohyInfo, function(j) {
			if (polohyInfo[j] != "") {
				var polohaAPoradi = polohyInfo[j].split('%');
				polohyAPoradi.push(polohaAPoradi);
			}
		});
		return polohyAPoradi;
	}

	function disableElement(element) {
		$(element).attr("class", "btn btn-default");
		$(element).attr("disabled", "disabled");
	}

	// uprava vzhledu akordu pri mouseover
	var rychlostZvetseni = 400;
	$(document).on('mouseover touchstart', '.akord', function() {
		if (pocetVlakenScroll == 0) {
			$(this).text().replace(/\s/g, '');
			$(this).css('opacity', '0.7');
			$(this).css({
				'opacity' : '0.7'
			});
			$(this).prop('title', 'Klikněte pro zobrazení akordu.');
			$(this).animate({
				'zoom' : 1.2
			}, rychlostZvetseni);
			var offset = $(this).offset();
		}
	});
	$(document).on('mouseout touchend', '.akord', function() {
		if (pocetVlakenScroll == 0) {
			var text = $(this).text().replace(/\s/g, '');
			$(this).css('opacity', '1');
			$(this).animate({
				'zoom' : 1.0
			}, rychlostZvetseni);
			$('#akordPisenDetail').remove();
		}
	});
});

$(function() {
	var PISEN_NAZEV = 'pisen-nazev';
	var KAPELA_NAZEV = "kapela-nazev";
	var PISEN_BEGIN_CLASS = '<h2>';
	var PODNADPIS_BEGIN_CLASS = '<small>';
	var PODNADPIS_END_CLASS = '</small>';
	var PISEN_END_CLASS = '</h2>';
	var VERZE_BEGIN_CLASS = '<strong class="text-primary">';
	var VERZE_END_CLASS = '</strong>';
	var AKORD_BEGIN_CLASS = '<strong class="text-danger akord small"> ';
	var AKORD_END_CLASS = '</strong>';
	var TLUMIT_STRUNY_CLASS = '<br><strong class="text-danger">(Zatlumit struny)</strong>';
	var AKORD_END_CLASS_UVNITR = ' </strong></span>';
	var NEW_LINE = '<br />';
	var TEXT_BEGIN_CLASS = '<span class="text">';
	var TEXT_END_CLASS = '</span>';
	var PAGE_HEADER_BEGIN_CLASS = '<div class="page-header">';
	var PAGE_HEADER_END_CLASS = '</div>';
	var SCROLL_ELEMENT = 'body,html';
	var SCROLL_VELMI_POMALU = 800000;
	var SCROLL_POMALU = SCROLL_VELMI_POMALU / 3;
	var SCROLL_STREDNE = SCROLL_VELMI_POMALU / 5;
	var SCROLL_RYCHLE = SCROLL_VELMI_POMALU / 7;
	var SCROLL_VELMI_RYCHLE = SCROLL_VELMI_POMALU / 10;
	var FIXNI_ELEMENTY = ['#scroll_controller', '.zahlaviPisne', '#menu',
			'#navbar', '#canvasNoScroll'];
	var HIDDEN_ELEMENTY = ['#vyhledaniNoScroll', '#pisneNoScroll',
			'#pisenAkordy', '#akordInfoNoScroll'];
	var BUTTONY_ID_SCROLL = ['scrollVelmiPomalu', 'scrollPomalu',
			'scrollStred', 'scrollRychle', 'scrollVelmiRychle'];
	var HRANICE_SPATNE_FORMATOVANI_POCITADLO = 8;
	var HRANICE_DVA_SPATNE_FORMATOVANI_POCITADLO = 15;
	var POCET_MEZER_MALA_VZDALENOST = 2;
	var POCET_MEZER_STREDNI_VZDALENOST = 6;
	var POCET_MEZER_VELKA_VZDALENOST = 13;
	var SPECIALNI_POSUN_AKORDU = 2;
	var PISEN_SECTION_SCROLL_POSUN = 100;

	// Nacteni a ostylovani pisne
	var pisen = $('#container');
	if (pisen != null) {
		$('.zahlaviPisne').html(sestavZahlavi(pisen));
		pisen.html(codeSong(pisen));
	}

	// Ostylovani jedne pisne
	function codeSong(pisen) {
		var songTextPrep = pisen.text();
		var songTextNewLine = songTextPrep.replace(/\s{2,}/g, ' ');
		var songText = songTextNewLine.replace(/\n/g, '');
		var konecAkordu = false;
		var codetext = "";
		var znak;
		var pocitadlo = 0; // Pocita znaky na radku
		var akordyRadek = '';
		var minDelkaAkordRadek = (AKORD_BEGIN_CLASS.length + AKORD_END_CLASS.length);
		var radekBezAkordu = '';
		var zvysovatPocitadlo = false;
		var novyRadek = false;
		var isText = false;
		var delkaAkordu = 0;

		for (var i = 0; i < songText.length; i++) {
			znak = songText[i];
			switch (znak) {
				case '|' : // Zacatek nebo konec akordu za slovem
					akordMimoText(AKORD_END_CLASS);
					break;
				case '\\' : // Konec akordu uvnitr slova
					akordVneTextu(AKORD_END_CLASS_UVNITR);
					break;
				case '$' : // Konec akordu za slovem, specialni
					// posun
					pocitadlo = pocitadlo + SPECIALNI_POSUN_AKORDU;
					akordMimoText(AKORD_END_CLASS);
					break;
				case '^' : // Tlumeni strun
					radekBezAkordu += TLUMIT_STRUNY_CLASS;
					break;
				case '_' : // Novy radek
					radekBezAkordu += NEW_LINE;
					zvysovatPocitadlo = false;
					novyRadek = true;
					delkaAkordu = 0;
					akordyRadek += NEW_LINE;
					pridejRadek();
					break;
				case 'R' : // Refren
					if ((i < (songText.length - 2)) && (songText[i + 1] == ':')
							&& (songText[i + 2] == '_')) {
						pridejRefren('R:');
						i++;
					} else if ((i < (songText.length - 1))
							&& (songText[i + 1] == '_')) {
						pridejRefren('R');
					} else
						pridejText(znak); // Obycejny znak 'R'
					break;
				case '~' :
					if (songText[i + 1] == '=') { // Predehra = mezihra
						pridejPredehru();
						i++;
					} else // Mezihra
					{
						if (songText[i + 1] == '~') {
							pridejMezihru2();
							i++;
						} else {
							pridejMezihru();
						};

					}
					break;
				case '*' : // Dohra
					pridejDohru();
					break;
				case '=' : // Predehra
					pridejPredehruBezMezihry();
					break;
				default :
					if ((!isNaN(parseInt(znak))) && songText[i + 1] == '_') { // Cislo
						// sloky
						pridejSloku(znak);
					} else {
						pridejText(znak);
					}
					break;
			}
		}
		if (konecAkordu) {
			radekBezAkordu += AKORD_END_CLASS;
		}

		function akordMimoText(END_CLASS) {
			if (konecAkordu) {
				if (!novyRadek) {
					radekBezAkordu += '&nbsp;';
				};
				akordSpolecnaCast(END_CLASS);
			} else {
				sestavitRadekSAkordy(AKORD_BEGIN_CLASS, konecAkordu);
			}
			konecAkordu = !konecAkordu;
		}

		function akordVneTextu(END_CLASS) {
			if (konecAkordu) {
				akordSpolecnaCast(END_CLASS);
				konecAkordu = false;
			}
		}

		function akordSpolecnaCast(END_CLASS) {
			sestavitRadekSAkordy(END_CLASS, konecAkordu);
		}

		function pridejRadek() {
			if (akordyRadek.length > minDelkaAkordRadek || isText) {
				codetext += akordyRadek;
			};
			codetext += radekBezAkordu;
			resetRadek();
		}

		function resetRadek() {
			akordyRadek = '';
			pocitadlo = 0;
			radekBezAkordu = '';
			isText = false;
		}

		function sestavitRadekSAkordy(castAkordu, konecAkordu) {
			if (!konecAkordu) {
				;
				var mezery = '';
				if (pocitadlo > 0
						&& pocitadlo < HRANICE_SPATNE_FORMATOVANI_POCITADLO) {
					pocitadlo = pocitadlo + POCET_MEZER_MALA_VZDALENOST;
				} else {
					if (pocitadlo >= HRANICE_SPATNE_FORMATOVANI_POCITADLO
							&& pocitadlo < HRANICE_DVA_SPATNE_FORMATOVANI_POCITADLO) {
						pocitadlo = pocitadlo + POCET_MEZER_STREDNI_VZDALENOST;
					} else {
						if (pocitadlo >= HRANICE_DVA_SPATNE_FORMATOVANI_POCITADLO) {
							pocitadlo = pocitadlo
									+ POCET_MEZER_VELKA_VZDALENOST;
						};
					};;
				};
				pocitadlo = pocitadlo - delkaAkordu;
				if (pocitadlo < 0) {
					pocitadlo = 0;
				};

				for (var i = 0; i < (pocitadlo); i++) {
					mezery += '&nbsp;';
				};
				akordyRadek += mezery + castAkordu;
				pocitadlo = 0;
				delkaAkordu = 0;
			} else {
				akordyRadek += castAkordu;
			};
		}

		function pridejRefren(refren) {
			radekBezAkordu += NEW_LINE + VERZE_BEGIN_CLASS + refren
					+ VERZE_END_CLASS;
		}

		function pridejPredehru() {
			radekBezAkordu += NEW_LINE + VERZE_BEGIN_CLASS
					+ '~předehra = mezihra~' + VERZE_END_CLASS;
		}

		function pridejPredehruBezMezihry() {
			radekBezAkordu += NEW_LINE + VERZE_BEGIN_CLASS + '~předehra~'
					+ VERZE_END_CLASS;
		}

		function pridejMezihru() {
			radekBezAkordu += NEW_LINE + VERZE_BEGIN_CLASS + '~mezihra~'
					+ VERZE_END_CLASS;
		}

		function pridejMezihru2() {
			radekBezAkordu += NEW_LINE + VERZE_BEGIN_CLASS + '~mezihra 2~'
					+ VERZE_END_CLASS;
		}

		function pridejDohru() {
			radekBezAkordu += NEW_LINE + VERZE_BEGIN_CLASS + '~dohra~'
					+ VERZE_END_CLASS;
		}

		function pridejSloku(znak) {
			radekBezAkordu += NEW_LINE + VERZE_BEGIN_CLASS + znak + '.'
					+ VERZE_END_CLASS;
		}

		function pridejText(znak) {
			if (znak != ' ') { // pocitadlo se zvysuje az od prvniho znaku
				// textu
				zvysovatPocitadlo = true;
				if (!konecAkordu) { // Pokud je v textu jiny znak nez mezera.
					// Kvuli neodsazovani radku zacinajicich
					// akordem.
					novyRadek = false;
				};
			};
			if (konecAkordu) {
				delkaAkordu++;
				sestavitRadekSAkordy(znak, true);
			} else {
				if (zvysovatPocitadlo) {
					pocitadlo += 1;
					isText = true;
				};
				radekBezAkordu += TEXT_BEGIN_CLASS + znak + TEXT_END_CLASS;
			}
		}

		// Sestaveni vysledne pisne
		codeSong = codetext;

		return codeSong;
	}

	function sestavZahlavi(pisen) {
		var songName = pisen.data(PISEN_NAZEV), bandName = pisen
				.data(KAPELA_NAZEV);

		// Nazev pisne
		var codeZahlavi = PAGE_HEADER_BEGIN_CLASS + PISEN_BEGIN_CLASS
				+ songName + '&nbsp;';
		// Nazev skupiny
		codeZahlavi += PODNADPIS_BEGIN_CLASS + bandName + PODNADPIS_END_CLASS
				+ PISEN_END_CLASS;
		codeZahlavi += PAGE_HEADER_END_CLASS;

		return codeZahlavi;
	}

	// Zobrazeni / skryti akordu
	var schovat = true;
	$('#skrytAkordy').click(function() {
		if (!schovat) {
			$('.akord').removeClass('hidden');
			$('#akordData').removeClass('hidden');
			$('#skrytAkordy').removeClass('glyphicon glyphicon-plus');
			$('#skrytAkordy').addClass('glyphicon glyphicon-minus');
			$('#skrytAkordy span').text("   Schovat akordy");
			schovat = true;
		} else {
			$('.akord').addClass('hidden');
			$('#akordData').addClass('hidden');
			$('#skrytAkordy').removeClass('glyphicon glyphicon-minus');
			$('#skrytAkordy').addClass('glyphicon glyphicon-plus');
			$('#skrytAkordy span').text("   Zobrazit akordy");
			schovat = false;
		}
	});

	$('#vetsiFont').click(function() {
		zvetsitVelikost(true);
	});

	$('#mensiFont').click(function() {
		zvetsitVelikost(false);
	});

	function zvetsitVelikost(zvetsit) {
		var fontPosun = 2;
		var novaVelikost;
		var velikost = zjistiFontById("#normalFont");
		if (zvetsit) {
			novaVelikost = velikost + fontPosun;
		} else {
			novaVelikost = velikost - fontPosun;
		};
		$("#normalFont").css("font-size", novaVelikost + "px");

		// nastaveni resetu
		var reset = $("#resetFont span").text();
		var withoutLastCharacters = reset.substring(0, reset.indexOf('|') + 2);
		velikost = vratPuvodniVelikost(reset, withoutLastCharacters, velikost);
		var rozdilOdNormalnihoFontu = novaVelikost - velikost;
		var newReset = withoutLastCharacters + rozdilOdNormalnihoFontu;
		$("#resetFont span").text(newReset);
	}

	function zjistiFontById(id) {
		var font = $(id).css("font-size");
		var velikost = parseInt(font.substring(0, 2));
		return velikost;
	}

	function vratPuvodniVelikost(reset, withoutLastCharacters, velikost) {
		var pocetZnaku = reset.length - withoutLastCharacters.length;
		var puvodniHodnota = reset.substring(reset.length - pocetZnaku,
				reset.length);
		velikost = velikost - puvodniHodnota;
		return velikost;
	}

	$('#resetFont').click(function() {
		var velikost = zjistiFontById("#normalFont");
		var reset = $("#resetFont span").text();
		var withoutLastCharacters = reset.substring(0, reset.indexOf('|') + 2);
		velikost = vratPuvodniVelikost(reset, withoutLastCharacters, velikost);
		$("#normalFont").css("font-size", velikost + "px");
		$("#resetFont span").text(withoutLastCharacters + 0);
	});
	$("#autoscroll").click(function() {
		$("#scroll_controller").removeClass("hidden");
		$('#scrollStop').css({
			top : 30,
			bottom : 'auto'
		});
		$('#scrollStop').css({
			left : 10,
			right : 'auto'
		});

		pressKeyEvent();
	});

	$("#scrollVelmiPomalu").click(function() {
		scroll(SCROLL_VELMI_POMALU);
		vybranyScrollBtn = $(this).attr('id');
	});

	$("#scrollPomalu").click(function() {
		scroll(SCROLL_POMALU);
		vybranyScrollBtn = $(this).attr('id');
	});
	$("#scrollStred").click(function() {
		scroll(SCROLL_STREDNE);
		vybranyScrollBtn = $(this).attr('id');
	});
	$("#scrollRychle").click(function() {
		scroll(SCROLL_RYCHLE);
		vybranyScrollBtn = $(this).attr('id');
	});
	$("#scrollVelmiRychle").click(function() {
		scroll(SCROLL_VELMI_RYCHLE);
		vybranyScrollBtn = $(this).attr('id');
	});

	var nastavitFixniTridy = true;
	function scroll(speed) {
		if (pocetVlakenScroll == 0) {
			$("#pisenSection").height(
					$("#pisenSection").height() + PISEN_SECTION_SCROLL_POSUN);
		}
		pocetVlakenScroll++;
		nastavHiddenElementy(HIDDEN_ELEMENTY);
		$('#content').css({
			position : 'relative',
			top : '150px'
		});
		if (nastavitFixniTridy) {
			nastavFixniElementy(FIXNI_ELEMENTY);
			$('#scroll_controller').css({
				width : '20%'
			});
			nastavitFixniTridy = false;
		};
		nastavNaZastavit("#scrollPause");
		$(SCROLL_ELEMENT).animate({
			scrollTop : $(document).height()
		}, speed, 'linear');
	}

	$("#scrollStop").click(function() {
		if (pocetVlakenScroll > 0) {
			scrollPause();
		}
		$("#scroll_controller").addClass("hidden");
		$(document).off('keyup');
	});

	$("#scrollPause").click(function() {
		if (pocetVlakenScroll > 0) {
			scrollPause();
		} else {
			jQuery('#scrollStop').click();
		};
	});

	function scrollPause() {
		$("#pisenSection").height(
				$("#pisenSection").height() - PISEN_SECTION_SCROLL_POSUN);
		odebratHiddenElementy(HIDDEN_ELEMENTY);
		nastavitFixniTridy = true;
		nastavStatic('#content');
		positionStatic(FIXNI_ELEMENTY);
		stopAllScrolls();
		nastavNaZavrit("#scrollPause");
	}

	var vybranyScrollBtn = '';
	function pressKeyEvent() {
		$(document).off('keyup');
		$(document)
				.on(
						'keyup',
						function(evt) {
							var keyCode = (evt.keyCode
									? evt.keyCode
									: evt.which);
							switch (keyCode) {
								case (Key.ESC) :
									jQuery('#scrollStop').click();
									break;
								case (Key.PLUS) :
								case (Key.RIGHT) :
									var nextBtnID = getElementInArray(
											BUTTONY_ID_SCROLL,
											vybranyScrollBtn, true);
									nastavActivniElement(nextBtnID,
											BUTTONY_ID_SCROLL);
									break;
								case (Key.MINUS) :
								case (Key.LEFT) :
									var nextBtnID = getElementInArray(
											BUTTONY_ID_SCROLL,
											vybranyScrollBtn, false);
									nastavActivniElement(nextBtnID,
											BUTTONY_ID_SCROLL);
									break;
								case (Key.ENTER) :
									if (vybranyScrollBtn != '') {
										if (pocetVlakenScroll > 0) {
											jQuery('#scrollPause').click();
										} else {
											jQuery('#' + vybranyScrollBtn)
													.click();
										};
									}
									;
									break;
								default :
									// Zadna reakce
							}
						});
	}

	function nastavNaZastavit(elementID) {
		$(elementID).removeClass("glyphicon glyphicon-stop");
		$(elementID).addClass("glyphicon glyphicon-pause");
		$(elementID).prop('title', 'Zastavit');
	}

	function nastavNaZavrit(elementID) {
		$(elementID).removeClass("glyphicon glyphicon-pause");
		$(elementID).addClass("glyphicon glyphicon-stop");
		$(elementID).prop('title', 'Zavřít');
	}

	function stopAllScrolls() {
		for (var i = 0; i < pocetVlakenScroll; i++) {
			$(SCROLL_ELEMENT).stop();
		};
		pocetVlakenScroll = 0;
	}

	function nastavHiddenElementy(elementy) {
		$.each(elementy, function(i) {
			$(elementy[i]).addClass('hidden');
		});
	}

	function odebratHiddenElementy(elementy) {
		$.each(elementy, function(i) {
			$(elementy[i]).removeClass('hidden');
		});
	}

	function nastavActivniElement(element, seznam) {
		$.each(seznam, function(i) {
			var id = '#' + seznam[i];
			$(id).removeClass("active");
			if (seznam[i] == element) {
				$(id).addClass("active");
				vybranyScrollBtn = element;
			};
		});
	}

	function nastavFixniElementy(fixniElementy) {
		$.each(fixniElementy, function(i) {
			var position = new Position(fixniElementy[i]);
			positionFix(fixniElementy[i], position.top, position.left);
		});
	}

	function positionFix(elementID, top, left) {
		$(elementID).css({
			position : 'fixed',
			top : top,
			left : left
		});
	}

	function positionStatic(elementyID) {
		$.each(elementyID, function(i) {
			nastavStatic(elementyID[i]);
		});
	}

	function nastavStatic(elementID) {
		$(elementID).css({
			position : 'static'
		});
	}

	function getElementInArray(seznam, element, next) {
		if (element == '') {
			return seznam[0];
		};
		if (next) {
			return getNextElement(seznam, element);
		} else {
			return getPreviousElement(seznam, element);
		};
	}

	function getNextElement(seznam, element) {
		var elId;
		var idInArray = seznam.indexOf(element);
		if (idInArray < (seznam.length - 1)) {
			elId = idInArray + 1;
		} else {
			elId = 0;
		};
		return seznam[elId];
	}

	function getPreviousElement(seznam, element) {
		var elId;
		var idInArray = seznam.indexOf(element);
		if (idInArray > (0)) {
			elId = idInArray - 1;
		} else {
			elId = seznam.length - 1;
		};
		return seznam[elId];
	}
});

var Position = function(elementID) {
	var top = $(elementID).offset().top * 0.6;
	var left = $(elementID).offset().left;
	this.top = top;
	this.left = left;
};

var Key = {
	ENTER : 13,
	ESC : 27,
	PLUS : 107,
	MINUS : 109,
	RIGHT : 39,
	LEFT : 37
};